					;NACA 4-digit series generator - Umberto Barone

;;;Questo lisp  stato realizzato da Umberto Barone;
;;; gratis e vieto a chiunque di utilizzarlo a fini di lucro,
;;;pu essere liberamente utilizzato, modificato, distribuito;
;;;prego solo di lasciare la firma come riconoscimento dei diritti 
;;;intelettuali


;;;i file naca.dcl e guidanaca.html vanno collocati nella directory
;;;Support di autocad

;;;Per errori, aggiornamenti, personalizzazioni contattami qui
;;;u.barone@tiscali.it
;;;htpp://web.tiscalinet.it/umberweb

(defun c:naca  (/ dcl_id select	m_vl p_vl t_vl corda n_point center prof1* prof2* prof1
		profilo	ok_spl ascissa x_p teta	delta_teta CONT	DELTA_X	L_LWP L_UPP LIS
		LISTA_P_MCL M MAXCAMBER_LIST P P* PCAMBER_LIST THICKNESS_LIST TIC VAR_NEW
		VAR_OLD	Y Y_MCL	comand)
  (setq comand 2)			;comand=1 ok-button; comand=2 help-button
  (while (> comand 1)			;ciclo
    (if	(findfile "naca.dcl")		;cerca naca.dcl IF1
      (progn				;manca la serie NACA 00xx (simmetrica)
	(setq maxcamber_list '("1%" "2%" "3%" "4%" "5%" "6%" "7%" "8%" "9%")
	      pcamber_list   '("10%" "20%" "30%" "40%" "50%" "60%" "70%" "80%" "90%")
	      thickness_list '("1%" "2%" "3%" "4%" "5%"	"6%" "7%" "8%" "9%" "10%" "11%"
			       "12%" "13%" "14%" "15%" "16%" "17%" "18%" "19%" "20%" "21%"
			       "22%" "23%" "24%" "25%" "26%" "27%" "28%" "29%" "30%"))
	(setq dcl_id (load_dialog "naca.dcl")) ;carica naca.DCL
	(if (not (new_dialog "naca" dcl_id)) ;altrimenti esci
	  (exit))
	(set_tile "m_list" "3")		;pop-up m_list su 4
	(start_list "m_list")
	(mapcar 'add_list maxcamber_list)
	(end_list)
	(set_tile "p_list" "3")		;pop-up p_list su 4
	(start_list "p_list")
	(mapcar 'add_list pcamber_list)
	(end_list)
	(set_tile "t_list" "11")	;pop-up t_list su 12
	(start_list "t_list")
	(mapcar 'add_list thickness_list)
	(end_list)
	(action_tile "accept"		;OK ACTION
		     (strcat
		       "(progn  (setq m_vl (atof (get_tile \"m_list\")))"
					;leggi max camber
		       "(setq p_vl (atof  (get_tile \"p_list\")))" ;position camber
		       "(setq t_vl (atof (get_tile \"t_list\")))" ;thickness
		       "(setq corda (atof (get_tile \"eb_corda\")))" ;hord
		       "(setq n_point (atof (get_tile \"n_point\")))"
					;risoluzione profilo
		       "(setq ok_spl (atof (get_tile \"ok_spl\")))" ;curve spline
		       "(setq select (atof (get_tile \"select\")))"
		       "(cond ((= select 0)(setq xc (atof(get_tile \"eb_xc\")))"
		       "(setq yc  (atof(get_tile \"eb_yc\")))" ;coo centro se select=0
		       "(setq zc  (atof(get_tile \"eb_zc\")))))" "(done_dialog 1))"))
	(action_tile "cancel" "(done_dialog 0)") ;CANCEL ACTION
	(action_tile "select"
		     "(setq select $value)(update1)" ;controllo edit box coo centro
		     )
	(action_tile "info" "(info)")	;info action
	(action_tile "guida" "(done_dialog 2)") ;guida
	(setq comand (start_dialog))	;setta comand=start_dialog
	(unload_dialog dcl_id)
	(cond ((= comand 1)		;COND1
	       (cond ((= select 0) (setq center (list xc yc zc))) ;set centro se select=0
		     ((= select 1)	;altrimenti chiedi x centro
		      (setq center (getpoint "\nSeleziona  centro: ")))) ;end cond
	       (set_var)		;SETVAR
	       (command "_ucs" "_s" "old_ucs") ;salva ucs
	       (command "_ucs" "_n" center) ;nuovo ucs
	       (find_m_p_tic)		;trova parametri
	       (setq ascissa	 0
		     x_p	 (/ p corda)
		     lista_p_mcl nil	;eq p linea mean camber
		     l_upp	 nil	;profilo sup
		     l_lwp	 nil	;profilo inf
		     teta	 0
		     delta_teta	 (/ pi n_point))
	       (while (<= (/ ascissa corda) 1.0) ;fino alla fine x/c WHILE1
		 (if (<= (/ ascissa corda) x_p) ;se minore di p
		   (setq y_mcl (* (/ m (* x_p x_p))
				  (- (* 2.0 x_p (/ ascissa corda))
				     (expt (/ ascissa corda) 2.0))))
					;calc ordinata di mcl
		   (setq y_mcl (* (/ m (expt (- 1.0 x_p) 2.0))
				  (+ (- 1.0 (* 2.0 x_p))
				     (* 2.0 x_p (/ ascissa corda))
				     (- (expt (/ ascissa corda) 2.0)))))) ;end if
		 (setq y (* 5.0
			    ;;eq profilo
			    tic
			    (+ (* 0.2969 (sqrt (/ ascissa corda)))
			       (- (* 0.126 (/ ascissa corda)))
			       (- (* 0.3516 (expt (/ ascissa corda) 2.0)))
			       (* 0.2843 (expt (/ ascissa corda) 3.0))
			       (- (* 0.1015 (expt (/ ascissa corda) 4.0))))))
		 ;;crea lista di punti
		 (setq delta_x (* (/ corda 2.0)
				  (abs (- (cos teta) (cos (+ teta delta_teta))))))
		 ;;procedura x densit di punti semicircolare
		 (setq lista_p_mcl (cons (list ascissa y_mcl) lista_p_mcl)
		       l_upp	   (cons (list ascissa (+ y_mcl y)) l_upp)
		       l_lwp	   (cons (list ascissa (- y_mcl y)) l_lwp)
		       ascissa	   (+ ascissa delta_x) ;incrementa ascissa
		       teta	   (+ teta delta_teta))) ;end WHILE1
	       (setq lista_p_mcl (reverse lista_p_mcl) ;inverti le liste
		     l_upp	 (reverse l_upp)
		     l_lwp	 (reverse l_lwp))
	       (command "_pline" (foreach p lista_p_mcl (command p))) ;draw mcl
	       (command "_line" '(0 0 0) (list corda 0 0) "") ;draw chord
	       (command "_pline" (foreach p l_upp (command p))) ;disegna profilo sup
	       (setq prof1* (entlast))
	       (command "_pline" (foreach p l_lwp (command p)))
	       (setq prof2* (entlast))
	       (command "_pedit" prof1* "_j" prof2* "" "") ;join i due profili
	       (setq profilo (entlast))
	       (command "_pedit" profilo "_c" "") ;chiudi profilo
	       (cond ((= ok_spl 1) (command "_pedit" profilo "_s" ""))) ;spline?
	       (reset_var))		;end start_dialog 1
	      ((= comand 2)
	       (command "_.browser" (findfile "guidanaca.html"))) ;end start_dialog 2
	      )				;end COND1
	);end progn if1
      (alert "File .DCL non trovato nella support")) ;end IF1
    )					;end WHILE
  (princ))				;end defun

(princ "Digita naca per eseguire")

 ;__________________________________UPDATE1 (controllo coo centro edit box)__________________
(defun update1	()
  (cond	((= select "0")
	 (mode_tile "eb_xc" 0)		;enable
	 (mode_tile "eb_yc" 0)
	 (mode_tile "eb_zc" 0))
	((= select "1")
	 (mode_tile "eb_xc" 1)		;disable
	 (mode_tile "eb_yc" 1)
	 (mode_tile "eb_zc" 1)))	;end cond
  )

;;;;;;;;;;;;;;;;find_m_p_tic
(defun find_m_p_tic  ()
  (setq	m   (/ (* (+ m_vl 1) corda) 100.0) ;maxcamber
	tic (/ (* (+ t_vl 1) corda) 100.0)) ;thickness
  (cond	((= p_vl 0) (setq p* 10))	;positon camber
	((= p_vl 1) (setq p* 20))
	((= p_vl 2) (setq p* 30))
	((= p_vl 3) (setq p* 40))
	((= p_vl 4) (setq p* 50))
	((= p_vl 5) (setq p* 60))
	((= p_vl 6) (setq p* 70))
	((= p_vl 7) (setq p* 80))
	((= p_vl 8) (setq p* 90)))
  (setq p (/ (* p* corda) 100.0)))
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;SETVAR;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun set_var	()
  (setq lis '("CMDECHO" "OSMODE" "ucsicon")) ;lista system var da salvare
  (setq var_old (mapcar 'getvar lis))	;lista valori originali system var
  (setq var_new (list 0 0 1))		;lista valori
  (setq cont 0)				;contatore a 0
  (repeat (length lis)
    (setvar (nth cont lis) (nth cont var_new))
    (setq cont (1+ cont)))
  (princ))

;;*******************************RESETVAR***********************

(defun reset_var  ()
  (setq cont 0)				;contatore a 0
  (repeat (length lis)
    (setvar (nth cont lis) (nth cont var_old)) ;reset var
    (setq cont (1+ cont)))
  (command "_ucs" "_r" "old_ucs")	;restore ucs
  (command "_ucs" "_d" "old_ucs")	; delete ucs
  (princ))


 ;_______________________________info dialog_______________________________________
(defun info  (/ dcl_id1)
  (setq dcl_id1 (load_dialog "naca.dcl")) ;carica DCL
  (if (not (new_dialog "info" dcl_id1))
    (exit))
  (action_tile "accept" "(done_dialog)")
  (start_dialog)
  (unload_dialog dcl_id1)
  (princ))				;end defun